//EDefine.h

#ifndef _XDEFINE_H
#define _XDEFINE_H

#include <d3d9.h>
#include <d3dx9.h>
#include <vector>
#include "../xmlnode/StringUtil.h"

struct StaticVertex
{
	enum { FVF = (D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1) };
	D3DXVECTOR3	p;
	D3DXVECTOR3	n;
	D3DXVECTOR2	t;
};

struct  VertexInfo
{
	VertexInfo()
	{
		p.Set( 0, 0 , 0 );
		b[0] = b[1] = b[2] = 0;
		index = 0;
		n.Set( 0, 0, 0 );
		t.Set( 0, 0 );	
	}

	base::Vector3	p;			// pos
	float			b[3];		// blend weight
	unsigned		int index;	// index
	base::Vector3	n;			// normal
	base::Vector2	t;			// texture coord
};


template<typename T>
void stl_wipe_vector( std::vector<T>& rVector )
{
	std::vector<T> emptyData;
	rVector.swap( emptyData );
}

#endif