//ENode.cpp
#include "ENode.h"
#include "../xmlnode/XmlNode.h"

ENode::ENode( LPDIRECT3DDEVICE9 pDevice )
: m_pParent( NULL ) 
, m_child( NULL )
{
	m_pDevice = pDevice;
	D3DXMatrixIdentity( &m_matTM );
}
//-----------------------------------------------------------------------------
ENode::~ENode()
{
	//ڽ 
	{
		ChildList::iterator iter = m_child.begin();
		ChildList::iterator endIter = m_child.end();
		for( ; iter != endIter; ++iter )
		{
			delete (*iter);
		}
		m_child.clear();

	}
}
//-----------------------------------------------------------------------------
const char* ENode::GetClassName()
{
	return "ENode";
}
//-----------------------------------------------------------------------------
ENode* ENode::AttachChild( ENode* pChild )
{
	pChild->m_pParent = this;
	m_child.push_back( pChild );
	return pChild;
}
//-----------------------------------------------------------------------------
void ENode::DetachChild( ENode* pChild )
{
	ChildList::iterator iter = m_child.begin();
	ChildList::iterator endIter = m_child.end();
	for( ; iter != endIter; ++iter )
	{
		if( pChild == *iter )
		{
			delete (*iter);
			m_child.erase( iter );
			break;
		}
	}
}
//-----------------------------------------------------------------------------
ENode* ENode::GetParent()
{
	return m_pParent;
}
//-----------------------------------------------------------------------------
ENode* ENode::GetRoot()
{
	return m_pParent ? m_pParent->GetRoot() : this;
}
//-----------------------------------------------------------------------------
void ENode::Draw()
{
	OnDraw();
	ChildList::iterator iter = m_child.begin();
	ChildList::iterator endIter = m_child.end();
	for( ; iter != endIter; ++iter )
	{
		ENode* pChild = (ENode*)*iter;
		pChild->Draw();
	}	
}