//ENode.h

#ifndef _XNODE_H
#define _XNODE_H

#include <d3d9.h>
#include <d3dx9.h>
#include <list>
#include <string>
#include <vector>
#include "../tinyxml/tinyxml.h"

class ENode;
typedef std::vector<ENode*> ENodeVector;

class XmlNode;

class ENode
{
public:
	ENode( LPDIRECT3DDEVICE9 pDevice );
	virtual	~ENode();

public:
	virtual	const char*	GetClassName();

	ENode*				AttachChild( ENode* pChild );
	void				DetachChild( ENode* pChild );
	ENode*				GetRoot();
	ENode*				GetParent();

	std::string*		GetName();
	void				SetName( const char* szName );

	//
	virtual void		Draw();
protected:			
	virtual int			OnDraw() { return 1; }

protected:
	typedef std::list <ENode*>		ChildList;

	std::string				m_name;
	ENode*					m_pParent;
	ChildList				m_child;  
	LPDIRECT3DDEVICE9		m_pDevice;	

	D3DXMATRIXA16			m_matLocal;
	D3DXMATRIXA16			m_matTM;

};


#endif